<script setup lang="tsx">
import { Form, FormSchema } from '@/components/Form'
import { useForm } from '@/hooks/web/useForm'
import { PropType, reactive, watch } from 'vue'
import { useValidator } from '@/hooks/web/useValidator'
// import { getWorkFlowVisiableButton } from '@/api/csck/CsckFlow';

const { required } = useValidator()

const props = defineProps({
  currentRow: {
    type: Object as PropType<any>,
    default: () => null
  },
  actionType: {
    type: String,
    default: 'submit'
  }
})
const formSchema = reactive<FormSchema[]>([
  {
    field: 'ruleType',
    label: '加工规则类型：',
    component: 'Select',
    componentProps:{
      options: [
        {
          label: '指标规则',
          value: '0'
        },
        {
          label: 'SQL规则',
          value: '1'
        },
        {
          label: '存储过程规则',
          value: '2'
        }
      ]
    },
    value: '1'
  }
])

const rules = reactive({
  ruleType: [required()],
})

const { formRegister, formMethods } = useForm()
const { setValues, getFormData, getElFormExpose } = formMethods

const submit = async () => {
  const elForm = await getElFormExpose()
  const valid = await elForm?.validate().catch((err) => {
    console.log(err)
  })
  if (valid) {
    const formData = await getFormData()
    return formData
  }
}

watch(
  () => props.currentRow,
  (currentRow) => {
    if (!currentRow) return
    setValues(currentRow)
  },
  {
    deep: true,
    immediate: true
  }
)

defineExpose({
  submit
})
</script>

<template>
  <Form :rules="rules" @register="formRegister" :schema="formSchema" />
</template>

